/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : cnc
Version : 1.0
Date    : 16.02.2009
Author  : F4CG
Company : F4CG
Comments:


Chip type           : AT90USB1287
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 2048
*****************************************************/
eeprom unsigned char debug=0;
unsigned int tahometr=0;
//unsigned char current_ep=0;
//bit usb_connected=0;
unsigned char endpoints=3; // 0 - control; 1 - data in;  2 - data out.
int i;
unsigned char usb_configuration_nb=1;

#include <delay.h>

#include <90usb1287.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
#include <usbdefines.h>
#include <usblib.h>


interrupt [USB_ENDPOINT_PIPE] void usb_endpoint_isr(void)
{

   PORTF.4=1;
if (UDINT & 1)
   {
   PORTF.4=1;
   // Suspend interrupt

   }
if (UDINT & 4)
   {
      PORTF.4=1;

   if ((Usb_setup_received()>0) && (i == 0)) {UsbControlPacketProcessed();};
        if (data_recieve()>0) {;};
   }
if (UDINT & 8)
   {
    PORTF.4=1;
   // End Of Reset interrupt
  //enable_ep_interrupt(); // Place your code here
   }
if (UDINT & 0x10)
   {
   // Wake-up CPU interrupt
  PORTF.4=1; // Place your code here
   }
if (UDINT & 0x20)
   {

   // End Of Resume interrupt
   // Place your code here
   }
if (UDINT & 0x40)
   {

 PORTF.4=1;
   // Upstream Resume interrupt
   // Place your code here
   }
UDINT=0; // Clear the interrupt flags
}




interrupt [USB_GENERAL] void usb_general_isr(void)
{

if (USBINT & 1)
   {

   }
if (USBINT & 2)
   {
   // ID Transition interrupt
   // Place your code here
   }
USBINT=0; // Clear the interrupt flags
if (OTGINT & 1)
   {
   // SRP interrupt
   // Place your code here
   PORTF.4=1;
   }
if (OTGINT & 2)
   {

   // V-Bus Error interrupt
   // Place your code here
   }
if (OTGINT & 4)
   {

   // B-Connection Error interrupt
   // Place your code here
   }
if (OTGINT & 8)
   {
   // Role Exchange interrupt
   // Place your code here
   }
if (OTGINT & 0x10)
   {
   // HNP Error interrupt
   // Place your code here

   }
if (OTGINT & 0x20)
   {
    PORTF.4=1;
   // Suspend Time-out Error interrupt
   // Place your code here

   }
OTGINT=0; // Clear the interrupt flags
}



// External Interrupt 6 service routine
interrupt [EXT_INT6] void ext_int6_isr(void)
{
tahometr++;
}

// External Interrupt 7 service routine
interrupt [EXT_INT7] void ext_int7_isr(void)
{
// Place your code here

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
//#ifdef _OPTIMIZE_SIZE_
//#pragma optsize+
//#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
PORTA=0x00;
DDRA=0xFF;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTB=0x00;
DDRB=0x00;


// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0xF0;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=0 State1=T State0=T
PORTE=0x00;
DDRE=0x04;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=0
PORTF=0x00;
DDRF=0x1F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Timer 3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: On
// INT6 Mode: Rising Edge
// INT7: On
// INT7 Mode: Any change
EICRA=0x00;
EICRB=0x70;
EIMSK=0xC0;
EIFR=0xC0;
// PCINT0 interrupt: Off
// PCINT1 interrupt: Off
// PCINT2 interrupt: Off
// PCINT3 interrupt: Off
// PCINT4 interrupt: Off
// PCINT5 interrupt: Off
// PCINT6 interrupt: Off
// PCINT7 interrupt: Off
PCMSK0=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;
// Timer/Counter 3 Interrupt(s) initialization
TIMSK3=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// USB Controller initialization
// USB Mode: Device
// UID Pin: Off
// UVCON Pin: Off
// USB Pad Regulator: Off
// OTG Pad: Off
// VBUS Transition interrupt: Off
// ID Transition interrupt: Off
USBINT=0; // Clear the interrupt flags
// SRP interrupt: Off
// VBUS Error interrupt: Off
// B-Connection Error interrupt: Off
// Role Exchange interrupt: Off
// HNP Error interrupt: Off
// Suspend Time-out Error interrupt: Off
OTGIEN=0x00;

OTGINT=0; // Clear the interrupt flags
// SRP Method: VBUS pulsing

// USB Device mode general registers initialization
// Low Speed Mode: Off

// Suspend interrupt: Off
// Start Of Frame interrupt: Off
// End Of Reset interrupt: Off
// Wake-up CPU interrupt: Off
// End Of Resume interrupt: Off
// Upstream Resume interrupt: Off
//usb_start_device();

UDINT=0; // Clear the interrupt flags
// Endpoint 0 selected

UEIENX = 0;

 #asm("sei");

usb_start_device();     // USB
//UDIEN = 0b01111101;     // -  "end of reset"  -   !
init_ep0();
UEINT = 0;


while (!(USBSTA & 0b00000001)==1) {
    };                                       //wait for vbus connect
 #asm("sei");

SREG = SREG | 0b10000000;
usb_attach();           //
Usb_enable_suspend_interrupt();
Usb_enable_reset_interrupt();



while (1)
     {
 //  if (UEINT) {PORTF.4=1;
//};

    recieve_sof();
    recieve_reset();
    recieve_setup();








     };


}
