
#define LANG_ID              0x00
#define MAN_INDEX            0x01 
#define PRD_INDEX            0x02 
#define SRN_INDEX            0x03 

  
 unsigned int length_conf; 
  
  
   unsigned int wSWAP(unsigned int x)   // 
{ 
return ((((x)>>8)&0x00FF)|(((x)<<8)&0xFF00));
}
 
#define MSK_EP_DIR    0x7F
 
   #define structSTRING_DESCRIPTOR(NAME, LEN) struct NAME \
                                           { \
                                             byte   bLength; \
                                             byte   bDescriptorType; \
                                             uint16 wstring[LEN]; \
                                            }
  
  
  
  
   /*       */
#define GET_STATUS_DEVICE               0X8000
#define GET_STATUS_INTERF               0X8100
#define GET_STATUS_ENDPNT               0X8200
#define CLEAR_FEATURE_DEVICE            0X0001
#define CLEAR_FEATURE_INTERF            0X0101
#define CLEAR_FEATURE_ENDPNT            0X0201
#define SET_FEATURE_DEVICE              0X0003
#define SET_FEATURE_INTERF              0X0103
#define SET_FEATURE_ENDPNT              0X0203
#define SET_ADDRESS                     0X0005
#define GET_DESCRIPTOR_DEVICE           0X8006
#define GET_DESCRIPTOR_INTERF           0X8106
#define GET_DESCRIPTOR_ENDPNT           0X8206
#define SET_DESCRIPTOR                  0X0007
#define GET_CONFIGURATION               0X8008
#define SET_CONFIGURATION               0X0009
#define GET_INTERFACE                   0X810A
#define SET_INTERFACE                   0X010B
#define SYNCH_FRAME                     0X820C
#define GET_REPORT                      0XA101
 /*       */
#define DEVICE                          0X01
#define CONFIGURATION                   0X02
#define STRING                          0X03
#define INTERFACE                       0X04
#define ENDPOINT                        0X05
  /*        */
#define USB_CONFIG_BUSPOWERED           0X80
#define USB_CONFIG_SELFPOWERED          0X40
#define USB_CONFIG_REMOTEWAKEUP         0X20
   /*    ,     */
#define USB_SPECIFICATION         0X1001
#define DEVICE_CLASS         0X02
#define DEVICE_SUB_CLASS         0
#define NB_INTERFACE          2

#define EP_CONTROL_LENGTH     32
#define VENDOR_ID     0XEB03
#define PRODUCT_ID     0X0921
#define RELEASE_NUMBER     0X0000
#define DESC_MAKER_STR     0X0000
#define DESC_PRODUCT_STR     0X0000
#define DESC_SN_STR     0X0000
#define DEVICE_PROTOCOL     0
#define CONF_LENGTH     18
#define CONF_ATTRIBUTES         USB_CONFIG_BUSPOWERED
#define CONF_NB               1
#define CONF_INDEX            0
#define MAX_POWER             50          /* 100 mA */

#define NB_CONFIGURATION      1
   
#define USB_PRODUCT_NAME     {'C'<<8,'N'<<8,'C'<<8,' '<<8, 'S'<<8,'Y'<<8,'S'<<8,'T'<<8,'E'<<8,'M'<<8,'S'<<8}
#define USB_MANUFACTURER_NAME     {'R'<<8,'_'<<8,'L'<<8,'A'<<8, 'B'<<8}
#define USB_SERIAL_NUMBER     {'2'<<8,'.'<<8,'0'<<8}
#define LANGUAGE_ID     0X0904      
#define PRODUCT_NAME_LENGTH             11
#define MANUFACTURER_NAME_LENGTH        5     
#define SERIAL_NUMBER_LENGTH            3
#define LANGUAGE_ID_LENGTH              1     




//0-  
#define INTERFACE0_NB          0
#define ALTERNATE0             0
#define NB_ENDPOINT0           1
#define INTERFACE0_CLASS       0x02 /* CDC ACM Comm */
#define INTERFACE0_SUB_CLASS   0x02
#define INTERFACE0_PROTOCOL    0x01
#define INTERFACE0_INDEX       0







typedef struct
{
unsigned char    bmRequestType;
unsigned char    bRequest;
unsigned int    wValue;
unsigned int    wIndex;
unsigned int    wLength;
}  SETUP_PACKET;
    
typedef union 
{ 
SETUP_PACKET setup;
unsigned char    b[8];
unsigned int    wRequest;
}  usbsetuppacket;   
 usbsetuppacket usbs;  
 
    
struct usb_st_configuration_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned int wTotalLength;         
  unsigned char   bNumInterfaces;       
  unsigned char   bConfigurationValue;  
  unsigned char   iConfiguration;       
  unsigned char   bmAttibutes;          
  unsigned char   MaxPower;             
};
 
struct usb_st_interface_descriptor
{
  unsigned char bLength;                
  unsigned char bDescriptorType;        
  unsigned char bInterfaceNumber;       
  unsigned char bAlternateSetting;      
  unsigned char bNumEndpoints;          
  unsigned char bInterfaceClass;        
  unsigned char bInterfaceSubClass;     
 unsigned char bInterfaceProtocol;     
  unsigned char iInterface;             
}; 

 
 
 struct usb_st_device_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned int bscUSB;               
  unsigned char   bDeviceClass;         
  unsigned char   bDeviceSubClass;      
  unsigned char   bDeviceProtocol;      
  unsigned char   bMaxPacketSize0;      
  unsigned int idVendor;             
  unsigned int idProduct;            
  unsigned int bcdDevice;            
  unsigned char   iManufacturer;        
  unsigned char   iProduct;             
  unsigned char   iSerialNumber;        
  unsigned char   bNumConfigurations;   
}usb_device_descriptor=
{ 
  18, DEVICE, USB_SPECIFICATION, DEVICE_CLASS,
  DEVICE_SUB_CLASS, DEVICE_PROTOCOL, EP_CONTROL_LENGTH, VENDOR_ID, PRODUCT_ID,
  RELEASE_NUMBER, MAN_INDEX, PRD_INDEX, SRN_INDEX, NB_CONFIGURATION
};

 

struct usb_st_endpoint_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned char   bEndpointAddress;     
  unsigned char   bmAttributes;         
  unsigned int wMaxPacketSize;       
  unsigned char   bInterval;            
};
 

 struct  
{ struct usb_st_configuration_descriptor  cfg;
  struct usb_st_interface_descriptor      ifc;
 }
  usb_configuration =
  {
    { 9, CONFIGURATION, CONF_LENGTH, NB_INTERFACE, CONF_NB, CONF_INDEX, CONF_ATTRIBUTES, MAX_POWER},
    { 9, INTERFACE, INTERFACE0_NB, ALTERNATE0, NB_ENDPOINT0, INTERFACE0_CLASS, INTERFACE0_SUB_CLASS, INTERFACE0_PROTOCOL, INTERFACE0_INDEX }
};
       
       
       
struct usb_st_language
        {
        unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[LANGUAGE_ID_LENGTH];
        }usb_language =  {LANGUAGE_ID_LENGTH*2 + 2,STRING, LANGUAGE_ID};
           
struct usb_st_manufacturer
        {
         unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[MANUFACTURER_NAME_LENGTH];
        
        }  usb_manufacturer =  {MANUFACTURER_NAME_LENGTH*2 + 2,STRING, USB_MANUFACTURER_NAME};
           
struct usb_st_product
        {
        unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[PRODUCT_NAME_LENGTH];
        
        }   usb_product=  {PRODUCT_NAME_LENGTH*2 + 2,STRING, USB_PRODUCT_NAME};     
            
struct usb_st_serial_number
        {
         unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[SERIAL_NUMBER_LENGTH];
        
        }   usb_serial_number =  {SERIAL_NUMBER_LENGTH*2 + 2,STRING, USB_SERIAL_NUMBER};    
        
        