/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : cnc
Version : 1.0
Date    : 16.02.2009
Author  : F4CG
Company : F4CG
Comments: 


Chip type           : AT90USB1287
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 2048
*****************************************************/
eeprom unsigned char debug=0;   
unsigned int tahometr=0;
//unsigned char current_ep=0;                                    
//bit usb_connected=0; 
unsigned char endpoints=3; // 0 - control; 1 - data in;  2 - data out.
int i;
unsigned char usb_configuration_nb=1;
                     
// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90USB1287


#pragma used+
#pragma used+
sfrb PINA=0;
sfrb DDRA=1;
sfrb PORTA=2;
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb PINE=0xc;
sfrb DDRE=0xd;
sfrb PORTE=0xe;
sfrb PINF=0xf;
sfrb DDRF=0x10;
sfrb PORTF=0x11;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb TIFR3=0x18;
sfrb TIFR4=0x19;
sfrb TIFR5=0x1a;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb PLLCSR=0x29;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb OCDR=0x31;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb RAMPZ=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
#endasm




  
 unsigned int length_conf; 
unsigned int length_conf; 
  
  
   unsigned int wSWAP(unsigned int x)   // 
{ 
return ((((x)>>8)&0x00FF)|(((x)<<8)&0xFF00));
}
 
 
     
  
  
  
   /*       */
 /*       */
  /*        */
   /*    ,     */


   




//0-  







typedef struct
{
unsigned char    bmRequestType;
unsigned char    bRequest;
unsigned int    wValue;
unsigned int    wIndex;
unsigned int    wLength;
}  SETUP_PACKET;
    
typedef union 
{ 
SETUP_PACKET setup;
unsigned char    b[8];
unsigned int    wRequest;
}  usbsetuppacket;   
 usbsetuppacket usbs;  
 
    
struct usb_st_configuration_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned int wTotalLength;         
  unsigned char   bNumInterfaces;       
  unsigned char   bConfigurationValue;  
  unsigned char   iConfiguration;       
  unsigned char   bmAttibutes;          
  unsigned char   MaxPower;             
};
 
struct usb_st_interface_descriptor
{
  unsigned char bLength;                
  unsigned char bDescriptorType;        
  unsigned char bInterfaceNumber;       
  unsigned char bAlternateSetting;      
  unsigned char bNumEndpoints;          
  unsigned char bInterfaceClass;        
  unsigned char bInterfaceSubClass;     
 unsigned char bInterfaceProtocol;     
  unsigned char iInterface;             
}; 

 
 
 struct usb_st_device_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned int bscUSB;               
  unsigned char   bDeviceClass;         
  unsigned char   bDeviceSubClass;      
  unsigned char   bDeviceProtocol;      
  unsigned char   bMaxPacketSize0;      
  unsigned int idVendor;             
  unsigned int idProduct;            
  unsigned int bcdDevice;            
  unsigned char   iManufacturer;        
  unsigned char   iProduct;             
  unsigned char   iSerialNumber;        
  unsigned char   bNumConfigurations;   
}usb_device_descriptor=
{ 
  18, 0X01, 0X1001, 0X02,
  0, 0, 32, 0XEB03, 0X0921,
  0X0000, 0x01 , 0x02 , 0x03 , 1
};

 

struct usb_st_endpoint_descriptor
{
  unsigned char   bLength;              
  unsigned char   bDescriptorType;      
  unsigned char   bEndpointAddress;     
  unsigned char   bmAttributes;         
  unsigned int wMaxPacketSize;       
  unsigned char   bInterval;            
};
 

 struct  
{ struct usb_st_configuration_descriptor  cfg;
  struct usb_st_interface_descriptor      ifc;
 }
  usb_configuration =
  {
    { 9, 0X02, 18, 2, 1, 0, 0X80, 50          },
    { 9, 0X04, 0, 0, 1, 0x02 , 0x02, 0x01, 0 }
};
       
       
       
struct usb_st_language
        {
        unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[1     ];
        }usb_language =  {1     *2 + 2,0X03, 0X0904      };
           
struct usb_st_manufacturer
        {
         unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[5     ];
        
        }  usb_manufacturer =  {5     *2 + 2,0X03, {'R'<<8,'_'<<8,'L'<<8,'A'<<8, 'B'<<8}};
           
struct usb_st_product
        {
        unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[11];
        
        }   usb_product=  {11*2 + 2,0X03, {'C'<<8,'N'<<8,'C'<<8,' '<<8, 'S'<<8,'Y'<<8,'S'<<8,'T'<<8,'E'<<8,'M'<<8,'S'<<8}};     
            
struct usb_st_serial_number
        {
         unsigned char bLength;
        unsigned char bDescriptorType;
        unsigned int wstring[3];
        
        }   usb_serial_number =  {3*2 + 2,0X03, {'2'<<8,'.'<<8,'0'<<8}};    
        
        

//#include <90usb1287.h>
 
 /*
 PORTF.4=1;
#define Usb_read_byte()                 (UEPDATX)
#define Usb_write_byte(x)               (UEPDATX = x)
#define Usb_clear_rx_setup()            (UEINTX = UEINTX & Ob11110111 )

 
 
 
  #define Usb_set_stall_request()       (UECONX = UECONX | 0b00100000)
  #define Usb_clear_stall_request()       (UECONX = UECONX & 0b00100000)
  #define Usb_clear_stalled()       (UEINTX = UEINTX & 0b11111101)
  #define Usb_stall_sent()       ( UEINTX & ObOOOOOO1O )
*/
         
         
   
   
void freeze_clk(void)   
void freeze_clk(void)   
{
(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) | 0b00100000;
  
}           
    
void unfreeze_clk(void)   
{
(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) & 0b11011111;
  
}    
    
       
  void wait_pll_ready(void)   
{

  while (!(PLLCSR & (0b00000001))>0);
}       
   
void enable_ep_interrupt(void)   
{
(*(unsigned char *) 0xe2)=0x7D;
(*(unsigned char *) 0xf0) = (*(unsigned char *) 0xf0) | 0b11011111;  
}   
   
 void pll_start(void)   
{
PLLCSR = PLLCSR | 0b00000010;  
}   
   
    
    
    
         
         void Usb_clear_rx(void)   //
{


} 

 void set_direct_endpoint(unsigned char num)   //           1 -IN 
{                                             //                                        0 - OUT
(*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) & 0b11111110;
(*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | num;
}
     
   
      unsigned char Usb_rx_complete(void)   // 
{
if (((*(unsigned char *) 0xe8) & 0b00000100)>0) {
 return 1;   }
else  {  return 0;  
    };

} 
   
   
   unsigned char Usb_setup_received(void)   // setup ? >0  
{

unsigned char otv; 
otv=0;
if (((*(unsigned char *) 0xe8) & 0b00001000)) {otv = 1;};
return otv;
}
   
    
       unsigned char Usb_tx_complete(void)   //
{
if (((*(unsigned char *) 0xe8) & 0b00000001)>0) {
 return 1;   }
else  {  return 0;  
    };


} 
    
    
    void set_endpoint(unsigned char num)   //  
{ 
(*(unsigned char *) 0xe9) = (*(unsigned char *) 0xe9) & 0X11111000;
(*(unsigned char *) 0xe9) = (*(unsigned char *) 0xe9) | num;
}

       
unsigned char Usb_read_byte(void)   //   
{
return (*(unsigned char *) 0xf1);
}  

void usb_write_byte(unsigned char b)   //   
{
(*(unsigned char *) 0xf1) = b;
}  

void usb_clear_rx_setup(void)   
{
(*(unsigned char *) 0xe8) = ((*(unsigned char *) 0xe8)&0b11110111);
}  

void usb_set_stall_request(void)   
{
(*(unsigned char *) 0xeb) = (*(unsigned char *) 0xeb) | 0b00100000;
}  

void usb_clear_stall_request(void)   
{
(*(unsigned char *) 0xeb) = (*(unsigned char *) 0xeb) & 0b00100000;
}  

void usb_clear_stalled(void)   
{
(*(unsigned char *) 0xe8) = (*(unsigned char *) 0xe8) & 0b11111101;
}  

void WaitForOutZeroPacket()
{
  while ((!(Usb_rx_complete()>0)) || (Usb_setup_received()>0));
  Usb_clear_rx();
  set_direct_endpoint(0);
}


unsigned char usb_stall_sent(void)  
{
return ((*(unsigned char *) 0xe8) & 0b00000010);
}                 


   void Usb_set_tx_ready(void)   //    
{
(*(unsigned char *) 0xe8) = (*(unsigned char *) 0xe8) & 0b01111111;
} 

void SendDataFromFIFO(void)   
{
Usb_set_tx_ready();
while(!Usb_tx_complete());
} 
 

 unsigned char * usb_send_ep0_packet(unsigned char* tbuf, unsigned char data_length)   //
{
unsigned char* bbuf;
unsigned char iii;


set_endpoint(0);    
set_direct_endpoint(1);
bbuf = tbuf;


for (iii=0; iii<data_length; iii++) 
        {
        
        
        usb_write_byte(*bbuf);
        bbuf-=1;
        
        };
Usb_set_tx_ready();
return bbuf;


} 


void GetConfiguration(void)   // 
{
  set_direct_endpoint(1);
  usb_configuration_nb = 1;
  usb_write_byte(usb_configuration_nb);
  SendDataFromFIFO();

  WaitForOutZeroPacket();
}  


 void STALL(void)   // (   )
{
    
    usb_clear_rx_setup();
usb_set_stall_request();
while(!usb_stall_sent());
usb_clear_stall_request();
usb_clear_stalled();
set_direct_endpoint(0);
}


void SendInZeroPacket()
{
  SendDataFromFIFO();
 set_direct_endpoint(0);}


 void SetConfiguration(void)   //() 
{

unsigned char configuration_number;

  configuration_number = usbs.b[2];   


  if (configuration_number <= 1)
  {

    usb_configuration_nb = configuration_number;
  }
  else
  {
 
    STALL();
    return;
  }


  SendInZeroPacket();

  /* 䨣஢ 㣨  祪 */
/* ====
  usb_configure_endpoint(1 , BULK_IN);
  usb_reset_endpoint(1);
  usb_configure_endpoint(2 , BULK_OUT);
  usb_reset_endpoint(2);
  usb_configure_endpoint(3 , INTERRUPT_IN);
  usb_reset_endpoint(3);
  ==== */




} 


      void Usb_clear_tx_complete(void)   //
{


} 
       
      void Usb_clear_tx_ready(void)   //
{


} 
    
 

 void Usb_set_FADDEN(void)   // 
{
(*(unsigned char *) 0xe3) = (*(unsigned char *) 0xe3) | 0b10000000;
} 
 
 
 
 
 void GetDescriptor(void)   // 
{
unsigned char    data_to_transfer;
 unsigned int  wLength;
 bit          zlp;
 unsigned char   *pbuffer;


switch (usbs.b[3])
 {

    case 0X01: 
    {
      data_to_transfer = sizeof(usb_device_descriptor);
      pbuffer = &(usb_device_descriptor.bLength);
      break;
    }

    case 0X02: 
    {
      data_to_transfer = sizeof(usb_configuration);
      pbuffer = &(usb_configuration.cfg.bLength);
      break;
    }
  
    case 0X03:
    {
      switch (usbs.b[2])
      {
        case 0x00:
        {
          data_to_transfer = sizeof (usb_language);
          pbuffer = &(usb_language.bLength);
          break;
        }
        case 0x01 :
        {
          data_to_transfer = sizeof (usb_manufacturer);
          pbuffer = &(usb_manufacturer.bLength);
          break;
        }
        case 0x02 :
        {
          data_to_transfer = sizeof (usb_product);
          pbuffer = &(usb_product.bLength);
          break;
        }
        case 0x03 :
        {
          data_to_transfer = sizeof (usb_serial_number);
          pbuffer = &(usb_serial_number.bLength);
          break;
        }
        default:
        {
          STALL();
          return;
        }
      }
      break;
    }

    default:
    { 
      STALL();
      return;
    }
 
 wLength = wSWAP(usbs.setup.wLength);

   if (wLength > data_to_transfer)
  {
  
    if ((data_to_transfer % 32) == 0) 
    { 
     zlp = 1; 
    }
    else 
    { 
     zlp = 0; 
    }
  }
  else
  {

    data_to_transfer = (unsigned char)wLength;      
  }


  set_direct_endpoint(1);                           

  while (data_to_transfer > 32)
  {

    pbuffer = usb_send_ep0_packet(pbuffer, 32);

    data_to_transfer -= 32;


    Usb_set_tx_ready();
    while ((!(Usb_rx_complete()>0)) && (!(Usb_tx_complete()>0)));
    Usb_clear_tx_complete();
    if ((Usb_rx_complete())) 
    {
      Usb_clear_tx_ready(); 
      Usb_clear_rx();
      return;
    }
  }

  pbuffer = usb_send_ep0_packet(pbuffer, data_to_transfer);
  data_to_transfer = 0;
  Usb_set_tx_ready();
  while ((!(Usb_rx_complete()>0)) && (!(Usb_tx_complete()>0)));
  Usb_clear_tx_complete();
  if ((Usb_rx_complete())) 
  {
    Usb_clear_tx_ready();
    Usb_clear_rx();
    return;
  }

  


  if (zlp == 1)
  {
    Usb_set_tx_ready();
    while ((!(Usb_rx_complete())) && (!(Usb_tx_complete())));
    Usb_clear_tx_complete();
    if ((Usb_rx_complete())) 
    {
      Usb_clear_tx_ready();
      Usb_clear_rx();
      set_direct_endpoint(0);  
      return;
    }

  }

  while ((!(Usb_rx_complete())) && (!(Usb_setup_received())));
  if (Usb_setup_received())
  {
    return;
  }

  if (Usb_rx_complete())
  {
set_direct_endpoint(0);
    Usb_clear_rx();
  }
 
  }

} 


 void GetStatusDevice(void)   // 
{
set_direct_endpoint(1);

  usb_write_byte(0x00);  
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();

} 

 void GetStatusInterf(void)   //  
{
set_direct_endpoint(1);

  usb_write_byte(0x00);          
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();

} 

 void GetStatusEndpoint(void)   //  
{
unsigned char wIndex;

 
  wIndex = usbs.b[4] & 0x7F;

set_direct_endpoint(1);

  usb_write_byte(0x00);
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();


} 


 void Usb_configure_address(unsigned char ad)   //  
{
(*(unsigned char *) 0xe3) = 0b01111111 & ad;

} 


void SetAddress()
{
 
  Usb_set_FADDEN();        
  SendInZeroPacket();

  Usb_configure_address(usbs.b[2]);
}


 void UsbControlPacketProcessed(void)   // 
{
 unsigned char ii;



for (ii=0; ii<8; ii++) { usbs.b[ii] = Usb_read_byte();};

switch (usbs.b[3]) {
    case 0X8000:
     GetStatusDevice();   
     break;

    case 0X8100:     
     GetStatusInterf();   
     break;

    case 0X8200:     
     GetStatusEndpoint();   
     break;

    case 0X8006:
    case 0X8106:
    case 0X8206:
     GetDescriptor(); 
     break;

    case 0X8008:
     GetConfiguration();         
     break;

    case 0X0009:     
     SetConfiguration();
     break;

    case 0X0005:
     SetAddress();   
     break;

    default:
     STALL();
     break;
(*(unsigned char *) 0xe8) = (*(unsigned char *) 0xe8) & 0b11110111;
    };

















} 


void usb_attach()   // USB
{
(*(unsigned char *) 0xe0) = (*(unsigned char *) 0xe0) & 0b11111110;
}

void reset_endpoint(unsigned char num)   //   num
{

switch (num) {
    case 0 :  
    (*(unsigned char *) 0xea) = ((*(unsigned char *) 0xea) & 11111110)|00000001;
    
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11111110;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00000001;
    break;  
    
    
    case 1 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11111101;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00000010;
    break;
    
    
    case 2 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11111011;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00000100;
    break;
        
    case 3 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11110111;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00001001;
    break;
    
    
    
    case 4 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11101111;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00010001;
    break;
    
    
    case 5 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11011111;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00100001;
    break;
    
    
    case 6 : 
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b10111111;
    (*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b01000001;
    break;
    
    }; 



}

void usb_detach()   // USB
{
(*(unsigned char *) 0xe0) = (*(unsigned char *) 0xe0) | 0b00000001;
}

void set_mode_endpoint(unsigned char num)   //        0 - control               1 -         
{                                           //                                2 -      3 -     
(*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) & 0X00111111;


switch (num) {
    case 0:
   (*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | 0b00000000;
    break;
    
    case 1:
   (*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | 0b01000000;
    break;
    
    case 2:
   (*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | 0b10000000;
    break;
     
    
    case 3:
   (*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | 0b11000000;
    break;
       
    default:  (*(unsigned char *) 0xec) = (*(unsigned char *) 0xec) | 0b00000000;
    };
}

void usb_init(void)   // USB
{

usb_detach();
delay_ms(50);  


usb_attach();

//reset_endpoint(0);

}

data_recieve(void)   //// ?     >0  
{
unsigned char otv;
if ((*(unsigned char *) 0xe8) & 0b00000100) {otv = 3;};
return otv;
}   
       
/*
void setup_m(void)   ////  setup
{   


switch (usbs.wRequest) {
    case GET_STATUS_DEVICE : GetStatusDevice();
    break;
            
    case GET_STATUS_INTERF : GetStatusInterf();
    break;   
       
    case GET_STATUS_ENDPNT : GetStatusEndpoint();
    break;   
       
    case GET_DESCRIPTOR_DEVICE : 
    case GET_DESCRIPTOR_INTERF : 
    case GET_DESCRIPTOR_ENDPNT : 
      GetDescriptor();
    break;   
       
    case GET_CONFIGURATION : GetConfiguration();
    break;   
       
    case SET_CONFIGURATION : SetConfiguration();
    break;   
       
    case SET_ADDRESS : SetAddress();
    break;   
       
       
       
    default: STALL();
    };





}           
*/

void disable_usb (void)
{
(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) & 0b01111111;
}

void enable_usb (void)
{
(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) | 0b10000000;

}

void reset_macro_usb (void)
{


(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) & 0b01111111;

(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) | 0b10000000;

}




void Usb_enable_suspend_interrupt (void)
{
 (*(unsigned char *) 0xe2) = (*(unsigned char *) 0xe2) | 0b00000001;
}


void Usb_enable_reset_interrupt(void)
{
(*(unsigned char *) 0xe2) = (*(unsigned char *) 0xe2) | 0b00001000;
}




void init_ep0(void)
{
(*(unsigned char *) 0xe9)=0;
(*(unsigned char *) 0xeb)=0x01;
(*(unsigned char *) 0xec)=0x00;
(*(unsigned char *) 0xed)=0b00100000;
(*(unsigned char *) 0xed)=(*(unsigned char *) 0xed) | 0b00000010;


(*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) | 0b00000001;
delay_ms(1);
(*(unsigned char *) 0xea) = (*(unsigned char *) 0xea) & 0b11111110;


if (!((*(unsigned char *) 0xee) & 0b10000000)==0) 
{ 
; 
} else {PORTF.4 = 1;};
}




void usb_start_device (void)
{ 


(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) & 0b00111111;           //. USB

(*(unsigned char *) 0xd7) = (*(unsigned char *) 0xd7) | 0b00000001;           //Power ON USB

delay_ms(15);                           // 15 
            
   
   
   // PLL
                PLLCSR = 0b00010100;  
                pll_start();
                wait_pll_ready();
   
   
 (*(unsigned char *) 0xe0) = 0b00000100;  

(*(unsigned char *) 0xd7) = (*(unsigned char *) 0xd7) | 0b10000000;                //set device mode
(*(unsigned char *) 0xd7) = (*(unsigned char *) 0xd7) & 0b10101111;               //              



(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) | 0b00010000; 
(*(unsigned char *) 0xd8) = (*(unsigned char *) 0xd8) | 0b10100000;           //Enable OTG, Enable USB and Disable Clock...
                
                
                
               
unfreeze_clk();                        //  USB

            //FULL SPEED mode


///UDADDR = 0;                                       //Reset address
(*(unsigned char *) 0xe2) = 0;
(*(unsigned char *) 0xe8) = 0;
}




void recieve_reset(void)
{
   
if ((*(unsigned char *) 0xe1) & 0b00001000) {   
 
 
 (*(unsigned char *) 0xf0) = 0b11011111;
 (*(unsigned char *) 0xea) = 0b00000111;
 (*(unsigned char *) 0xea) = 0b00000000;
 (*(unsigned char *) 0xe2) = (*(unsigned char *) 0xe2) | 0b00000100;

 (*(unsigned char *) 0xe1) = (*(unsigned char *) 0xe1) & 0b11110111;
 (*(unsigned char *) 0xe1) =0;
 (*(unsigned char *) 0xe9)=0;
                        };

}



void recieve_setup(void)
{
   
if ((*(unsigned char *) 0xe8) & 0b00101000) {   
 (*(unsigned char *) 0xe8) = (*(unsigned char *) 0xe8) & 0b11110111;
 PORTF.4=1;
 UsbControlPacketProcessed();
 
                        };

}

void recieve_sof(void)
{
   
if ((*(unsigned char *) 0xe1) & 0b00000100) {   
 (*(unsigned char *) 0xe1) = (*(unsigned char *) 0xe1) & 0b11111011;
 
 
 
                        };

}


      

interrupt [12] void usb_endpoint_isr(void)
{
     
   PORTF.4=1;
if ((*(unsigned char *) 0xe1) & 1)
   {
   PORTF.4=1;
   // Suspend interrupt
  
   }
if ((*(unsigned char *) 0xe1) & 4)
   {
      PORTF.4=1;

   if ((Usb_setup_received()>0) && (i == 0)) {UsbControlPacketProcessed();};
        if (data_recieve()>0) {;};
   }
if ((*(unsigned char *) 0xe1) & 8)
   {
    PORTF.4=1;
   // End Of Reset interrupt
  //enable_ep_interrupt(); // Place your code here
   }
if ((*(unsigned char *) 0xe1) & 0x10)
   {
   // Wake-up CPU interrupt
  PORTF.4=1; // Place your code here
   }
if ((*(unsigned char *) 0xe1) & 0x20)
   {
   
   // End Of Resume interrupt
   // Place your code here
   }
if ((*(unsigned char *) 0xe1) & 0x40)
   {
      
 PORTF.4=1;
   // Upstream Resume interrupt
   // Place your code here
   }
(*(unsigned char *) 0xe1)=0; // Clear the interrupt flags
}




interrupt [11] void usb_general_isr(void)
{
   
if ((*(unsigned char *) 0xda) & 1)
   {  
              
   }
if ((*(unsigned char *) 0xda) & 2)
   {
   // ID Transition interrupt
   // Place your code here
   }
(*(unsigned char *) 0xda)=0; // Clear the interrupt flags
if ((*(unsigned char *) 0xdf) & 1)
   {
   // SRP interrupt
   // Place your code here
   PORTF.4=1;
   }
if ((*(unsigned char *) 0xdf) & 2)
   { 
   
   // V-Bus Error interrupt
   // Place your code here
   }
if ((*(unsigned char *) 0xdf) & 4)
   {
   
   // B-Connection Error interrupt
   // Place your code here
   }
if ((*(unsigned char *) 0xdf) & 8)
   {
   // Role Exchange interrupt
   // Place your code here
   }
if ((*(unsigned char *) 0xdf) & 0x10)
   {
   // HNP Error interrupt
   // Place your code here

   }
if ((*(unsigned char *) 0xdf) & 0x20)
   {
    PORTF.4=1;
   // Suspend Time-out Error interrupt
   // Place your code here

   }
(*(unsigned char *) 0xdf)=0; // Clear the interrupt flags
}



// External Interrupt 6 service routine
interrupt [8] void ext_int6_isr(void)
{
tahometr++;
}

// External Interrupt 7 service routine
interrupt [9] void ext_int7_isr(void)
{
// Place your code here

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
(*(unsigned char *) 0x61)=0x80;
(*(unsigned char *) 0x61)=0x00;
//#ifdef _OPTIMIZE_SIZE_
//#pragma optsize+
//#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0xFF;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;
                                    
 
// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xF0;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=0 State1=T State0=T 
PORTE=0x00;
DDRE=0x04;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=0 
PORTF=0x00;
DDRF=0x1F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x00;
(*(unsigned char *) 0x8d)=0x00;
(*(unsigned char *) 0x8c)=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
(*(unsigned char *) 0xb6)=0x00;
(*(unsigned char *) 0xb0)=0x00;
(*(unsigned char *) 0xb1)=0x00;
(*(unsigned char *) 0xb2)=0x00;
(*(unsigned char *) 0xb3)=0x00;
(*(unsigned char *) 0xb4)=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Timer 3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
(*(unsigned char *) 0x90)=0x00;
(*(unsigned char *) 0x91)=0x00;
(*(unsigned char *) 0x95)=0x00;
(*(unsigned char *) 0x94)=0x00;
(*(unsigned char *) 0x97)=0x00;
(*(unsigned char *) 0x96)=0x00;
(*(unsigned char *) 0x99)=0x00;
(*(unsigned char *) 0x98)=0x00;
(*(unsigned char *) 0x9b)=0x00;
(*(unsigned char *) 0x9a)=0x00;
(*(unsigned char *) 0x9d)=0x00;
(*(unsigned char *) 0x9c)=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: On
// INT6 Mode: Rising Edge
// INT7: On
// INT7 Mode: Any change
(*(unsigned char *) 0x69)=0x00;
(*(unsigned char *) 0x6a)=0x70;
EIMSK=0xC0;
EIFR=0xC0;
// PCINT0 interrupt: Off
// PCINT1 interrupt: Off
// PCINT2 interrupt: Off
// PCINT3 interrupt: Off
// PCINT4 interrupt: Off
// PCINT5 interrupt: Off
// PCINT6 interrupt: Off
// PCINT7 interrupt: Off
(*(unsigned char *) 0x6b)=0x00;
(*(unsigned char *) 0x68)=0x00;

// Timer/Counter 0 Interrupt(s) initialization
(*(unsigned char *) 0x6e)=0x00;
// Timer/Counter 1 Interrupt(s) initialization
(*(unsigned char *) 0x6f)=0x00;
// Timer/Counter 2 Interrupt(s) initialization
(*(unsigned char *) 0x70)=0x00;
// Timer/Counter 3 Interrupt(s) initialization
(*(unsigned char *) 0x71)=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

// USB Controller initialization
// USB Mode: Device
// UID Pin: Off
// UVCON Pin: Off
// USB Pad Regulator: Off
// OTG Pad: Off
// VBUS Transition interrupt: Off
// ID Transition interrupt: Off
(*(unsigned char *) 0xda)=0; // Clear the interrupt flags
// SRP interrupt: Off
// VBUS Error interrupt: Off
// B-Connection Error interrupt: Off
// Role Exchange interrupt: Off
// HNP Error interrupt: Off
// Suspend Time-out Error interrupt: Off
(*(unsigned char *) 0xde)=0x00;

(*(unsigned char *) 0xdf)=0; // Clear the interrupt flags
// SRP Method: VBUS pulsing

// USB Device mode general registers initialization
// Low Speed Mode: Off

// Suspend interrupt: Off
// Start Of Frame interrupt: Off
// End Of Reset interrupt: Off
// Wake-up CPU interrupt: Off
// End Of Resume interrupt: Off
// Upstream Resume interrupt: Off
//usb_start_device(); 

(*(unsigned char *) 0xe1)=0; // Clear the interrupt flags
// Endpoint 0 selected

(*(unsigned char *) 0xf0) = 0;

 #asm("sei");
 
usb_start_device();     // USB
//UDIEN = 0b01111101;     // -  "end of reset"  -   !
init_ep0();
(*(unsigned char *) 0xf4) = 0;


while (!((*(unsigned char *) 0xd9) & 0b00000001)==1) {
    };                                       //wait for vbus connect
 #asm("sei");

SREG = SREG | 0b10000000;
usb_attach();           //
Usb_enable_suspend_interrupt(); 
Usb_enable_reset_interrupt();


 
while (1)
     {   
 //  if (UEINT) {PORTF.4=1;
//};

    recieve_sof();
    recieve_reset();
    recieve_setup();
    
    
    
    
    

  

     };


}       
