
//#include <90usb1287.h>
 
 /*
 PORTF.4=1;
#define Usb_read_byte()                 (UEPDATX)
#define Usb_write_byte(x)               (UEPDATX = x)
#define Usb_clear_rx_setup()            (UEINTX = UEINTX & Ob11110111 )

 
 
 
  #define Usb_set_stall_request()       (UECONX = UECONX | 0b00100000)
  #define Usb_clear_stall_request()       (UECONX = UECONX & 0b00100000)
  #define Usb_clear_stalled()       (UEINTX = UEINTX & 0b11111101)
  #define Usb_stall_sent()       ( UEINTX & ObOOOOOO1O )
*/
         
         
   
   
void freeze_clk(void)   
{
USBCON = USBCON | 0b00100000;
  
}           
    
void unfreeze_clk(void)   
{
USBCON = USBCON & 0b11011111;
  
}    
    
       
  void wait_pll_ready(void)   
{

  while (!(PLLCSR & (0b00000001))>0);
}       
   
void enable_ep_interrupt(void)   
{
UDIEN=0x7D;
UEIENX = UEIENX | 0b11011111;  
}   
   
 void pll_start(void)   
{
PLLCSR = PLLCSR | 0b00000010;  
}   
   
    
    
    
         
         void Usb_clear_rx(void)   //
{


} 

 void set_direct_endpoint(unsigned char num)   //           1 -IN 
{                                             //                                        0 - OUT
UECFG0X = UECFG0X & 0b11111110;
UECFG0X = UECFG0X | num;
}
     
   
      unsigned char Usb_rx_complete(void)   // 
{
if ((UEINTX & 0b00000100)>0) {
 return 1;   }
else  {  return 0;  
    };

} 
   
   
   unsigned char Usb_setup_received(void)   // setup ? >0  
{

unsigned char otv; 
otv=0;
if ((UEINTX & 0b00001000)) {otv = 1;};
return otv;
}
   
    
       unsigned char Usb_tx_complete(void)   //
{
if ((UEINTX & 0b00000001)>0) {
 return 1;   }
else  {  return 0;  
    };


} 
    
    
    void set_endpoint(unsigned char num)   //  
{ 
UENUM = UENUM & 0X11111000;
UENUM = UENUM | num;
}

       
unsigned char Usb_read_byte(void)   //   
{
return UEDATX;
}  

void usb_write_byte(unsigned char b)   //   
{
UEDATX = b;
}  

void usb_clear_rx_setup(void)   
{
UEINTX = (UEINTX&0b11110111);
}  

void usb_set_stall_request(void)   
{
UECONX = UECONX | 0b00100000;
}  

void usb_clear_stall_request(void)   
{
UECONX = UECONX & 0b00100000;
}  

void usb_clear_stalled(void)   
{
UEINTX = UEINTX & 0b11111101;
}  

void WaitForOutZeroPacket()
{
  while ((!(Usb_rx_complete()>0)) || (Usb_setup_received()>0));
  Usb_clear_rx();
  set_direct_endpoint(0);
}


unsigned char usb_stall_sent(void)  
{
return (UEINTX & 0b00000010);
}                 


   void Usb_set_tx_ready(void)   //    
{
UEINTX = UEINTX & 0b01111111;
} 

void SendDataFromFIFO(void)   
{
Usb_set_tx_ready();
while(!Usb_tx_complete());
} 
 

 unsigned char * usb_send_ep0_packet(unsigned char* tbuf, unsigned char data_length)   //
{
unsigned char* bbuf;
unsigned char iii;


set_endpoint(0);    
set_direct_endpoint(1);
bbuf = tbuf;


for (iii=0; iii<data_length; iii++) 
        {
        
        
        usb_write_byte(*bbuf);
        bbuf-=1;
        
        };
Usb_set_tx_ready();
return bbuf;


} 


void GetConfiguration(void)   // 
{
  set_direct_endpoint(1);
  usb_configuration_nb = CONF_NB;
  usb_write_byte(usb_configuration_nb);
  SendDataFromFIFO();

  WaitForOutZeroPacket();
}  


 void STALL(void)   // (   )
{
    
    usb_clear_rx_setup();
usb_set_stall_request();
while(!usb_stall_sent());
usb_clear_stall_request();
usb_clear_stalled();
set_direct_endpoint(0);
}


void SendInZeroPacket()
{
  SendDataFromFIFO();
 set_direct_endpoint(0);}


 void SetConfiguration(void)   //() 
{

unsigned char configuration_number;

  configuration_number = usbs.b[2];   


  if (configuration_number <= CONF_NB)
  {

    usb_configuration_nb = configuration_number;
  }
  else
  {
 
    STALL();
    return;
  }


  SendInZeroPacket();

  /* 䨣஢ 㣨  祪 */
/* ====
  usb_configure_endpoint(1 , BULK_IN);
  usb_reset_endpoint(1);
  usb_configure_endpoint(2 , BULK_OUT);
  usb_reset_endpoint(2);
  usb_configure_endpoint(3 , INTERRUPT_IN);
  usb_reset_endpoint(3);
  ==== */




} 


      void Usb_clear_tx_complete(void)   //
{


} 
       
      void Usb_clear_tx_ready(void)   //
{


} 
    
 

 void Usb_set_FADDEN(void)   // 
{
UDADDR = UDADDR | 0b10000000;
} 
 
 
 
 
 void GetDescriptor(void)   // 
{
unsigned char    data_to_transfer;
 unsigned int  wLength;
 bit          zlp;
 unsigned char   *pbuffer;


switch (usbs.b[3])
 {

    case DEVICE: 
    {
      data_to_transfer = sizeof(usb_device_descriptor);
      pbuffer = &(usb_device_descriptor.bLength);
      break;
    }

    case CONFIGURATION: 
    {
      data_to_transfer = sizeof(usb_configuration);
      pbuffer = &(usb_configuration.cfg.bLength);
      break;
    }
  
    case STRING:
    {
      switch (usbs.b[2])
      {
        case LANG_ID:
        {
          data_to_transfer = sizeof (usb_language);
          pbuffer = &(usb_language.bLength);
          break;
        }
        case MAN_INDEX:
        {
          data_to_transfer = sizeof (usb_manufacturer);
          pbuffer = &(usb_manufacturer.bLength);
          break;
        }
        case PRD_INDEX:
        {
          data_to_transfer = sizeof (usb_product);
          pbuffer = &(usb_product.bLength);
          break;
        }
        case SRN_INDEX:
        {
          data_to_transfer = sizeof (usb_serial_number);
          pbuffer = &(usb_serial_number.bLength);
          break;
        }
        default:
        {
          STALL();
          return;
        }
      }
      break;
    }

    default:
    { 
      STALL();
      return;
    }
 
 wLength = wSWAP(usbs.setup.wLength);

   if (wLength > data_to_transfer)
  {
  
    if ((data_to_transfer % EP_CONTROL_LENGTH) == 0) 
    { 
     zlp = 1; 
    }
    else 
    { 
     zlp = 0; 
    }
  }
  else
  {

    data_to_transfer = (unsigned char)wLength;      
  }


  set_direct_endpoint(1);                           

  while (data_to_transfer > EP_CONTROL_LENGTH)
  {

    pbuffer = usb_send_ep0_packet(pbuffer, EP_CONTROL_LENGTH);

    data_to_transfer -= EP_CONTROL_LENGTH;


    Usb_set_tx_ready();
    while ((!(Usb_rx_complete()>0)) && (!(Usb_tx_complete()>0)));
    Usb_clear_tx_complete();
    if ((Usb_rx_complete())) 
    {
      Usb_clear_tx_ready(); 
      Usb_clear_rx();
      return;
    }
  }

  pbuffer = usb_send_ep0_packet(pbuffer, data_to_transfer);
  data_to_transfer = 0;
  Usb_set_tx_ready();
  while ((!(Usb_rx_complete()>0)) && (!(Usb_tx_complete()>0)));
  Usb_clear_tx_complete();
  if ((Usb_rx_complete())) 
  {
    Usb_clear_tx_ready();
    Usb_clear_rx();
    return;
  }

  


  if (zlp == 1)
  {
    Usb_set_tx_ready();
    while ((!(Usb_rx_complete())) && (!(Usb_tx_complete())));
    Usb_clear_tx_complete();
    if ((Usb_rx_complete())) 
    {
      Usb_clear_tx_ready();
      Usb_clear_rx();
      set_direct_endpoint(0);  
      return;
    }

  }

  while ((!(Usb_rx_complete())) && (!(Usb_setup_received())));
  if (Usb_setup_received())
  {
    return;
  }

  if (Usb_rx_complete())
  {
set_direct_endpoint(0);
    Usb_clear_rx();
  }
 
  }

} 


 void GetStatusDevice(void)   // 
{
set_direct_endpoint(1);

  usb_write_byte(0x00);  
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();

} 

 void GetStatusInterf(void)   //  
{
set_direct_endpoint(1);

  usb_write_byte(0x00);          
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();

} 

 void GetStatusEndpoint(void)   //  
{
unsigned char wIndex;

 
  wIndex = usbs.b[4] & MSK_EP_DIR;

set_direct_endpoint(1);

  usb_write_byte(0x00);
  usb_write_byte(0x00);
  SendDataFromFIFO();

  WaitForOutZeroPacket();


} 


 void Usb_configure_address(unsigned char ad)   //  
{
UDADDR = 0b01111111 & ad;

} 


void SetAddress()
{
 
  Usb_set_FADDEN();        
  SendInZeroPacket();

  Usb_configure_address(usbs.b[2]);
}


 void UsbControlPacketProcessed(void)   // 
{
 unsigned char ii;



for (ii=0; ii<8; ii++) { usbs.b[ii] = Usb_read_byte();};

switch (usbs.b[3]) {
    case GET_STATUS_DEVICE:
     GetStatusDevice();   
     break;

    case GET_STATUS_INTERF:     
     GetStatusInterf();   
     break;

    case GET_STATUS_ENDPNT:     
     GetStatusEndpoint();   
     break;

    case GET_DESCRIPTOR_DEVICE:
    case GET_DESCRIPTOR_INTERF:
    case GET_DESCRIPTOR_ENDPNT:
     GetDescriptor(); 
     break;

    case GET_CONFIGURATION:
     GetConfiguration();         
     break;

    case SET_CONFIGURATION:     
     SetConfiguration();
     break;

    case SET_ADDRESS:
     SetAddress();   
     break;

    default:
     STALL();
     break;
UEINTX = UEINTX & 0b11110111;
    };

















} 


void usb_attach()   // USB
{
UDCON = UDCON & 0b11111110;
}

void reset_endpoint(unsigned char num)   //   num
{

switch (num) {
    case 0 :  
    UERST = (UERST & 11111110)|00000001;
    
    UERST = UERST & 0b11111110;
    UERST = UERST | 0b00000001;
    break;  
    
    
    case 1 : 
    UERST = UERST & 0b11111101;
    UERST = UERST | 0b00000010;
    break;
    
    
    case 2 : 
    UERST = UERST & 0b11111011;
    UERST = UERST | 0b00000100;
    break;
        
    case 3 : 
    UERST = UERST & 0b11110111;
    UERST = UERST | 0b00001001;
    break;
    
    
    
    case 4 : 
    UERST = UERST & 0b11101111;
    UERST = UERST | 0b00010001;
    break;
    
    
    case 5 : 
    UERST = UERST & 0b11011111;
    UERST = UERST | 0b00100001;
    break;
    
    
    case 6 : 
    UERST = UERST & 0b10111111;
    UERST = UERST | 0b01000001;
    break;
    
    }; 



}

void usb_detach()   // USB
{
UDCON = UDCON | 0b00000001;
}

void set_mode_endpoint(unsigned char num)   //        0 - control               1 -         
{                                           //                                2 -      3 -     
UECFG0X = UECFG0X & 0X00111111;


switch (num) {
    case 0:
   UECFG0X = UECFG0X | 0b00000000;
    break;
    
    case 1:
   UECFG0X = UECFG0X | 0b01000000;
    break;
    
    case 2:
   UECFG0X = UECFG0X | 0b10000000;
    break;
     
    
    case 3:
   UECFG0X = UECFG0X | 0b11000000;
    break;
       
    default:  UECFG0X = UECFG0X | 0b00000000;
    };
}

void usb_init(void)   // USB
{

usb_detach();
delay_ms(50);  


usb_attach();

//reset_endpoint(0);

}

data_recieve(void)   //// ?     >0  
{
unsigned char otv;
if (UEINTX & 0b00000100) {otv = 3;};
return otv;
}   
       
/*
void setup_m(void)   ////  setup
{   


switch (usbs.wRequest) {
    case GET_STATUS_DEVICE : GetStatusDevice();
    break;
            
    case GET_STATUS_INTERF : GetStatusInterf();
    break;   
       
    case GET_STATUS_ENDPNT : GetStatusEndpoint();
    break;   
       
    case GET_DESCRIPTOR_DEVICE : 
    case GET_DESCRIPTOR_INTERF : 
    case GET_DESCRIPTOR_ENDPNT : 
      GetDescriptor();
    break;   
       
    case GET_CONFIGURATION : GetConfiguration();
    break;   
       
    case SET_CONFIGURATION : SetConfiguration();
    break;   
       
    case SET_ADDRESS : SetAddress();
    break;   
       
       
       
    default: STALL();
    };





}           
*/

void disable_usb (void)
{
USBCON = USBCON & 0b01111111;
}

void enable_usb (void)
{
USBCON = USBCON | 0b10000000;

}

void reset_macro_usb (void)
{


USBCON = USBCON & 0b01111111;

USBCON = USBCON | 0b10000000;

}




void Usb_enable_suspend_interrupt (void)
{
 UDIEN = UDIEN | 0b00000001;
}


void Usb_enable_reset_interrupt(void)
{
UDIEN = UDIEN | 0b00001000;
}




void init_ep0(void)
{
UENUM=0;
UECONX=0x01;
UECFG0X=0x00;
UECFG1X=0b00100000;
UECFG1X=UECFG1X | 0b00000010;


UERST = UERST | 0b00000001;
delay_ms(1);
UERST = UERST & 0b11111110;


if (!(UESTA0X & 0b10000000)==0) 
{ 
; 
} else {PORTF.4 = 1;};
}




void usb_start_device (void)
{ 


USBCON = USBCON & 0b00111111;           //. USB

UHWCON = UHWCON | 0b00000001;           //Power ON USB

delay_ms(15);                           // 15 
            
   
   
   // PLL
                PLLCSR = 0b00010100;  
                pll_start();
                wait_pll_ready();
   
   
 UDCON = 0b00000100;  

UHWCON = UHWCON | 0b10000000;                //set device mode
UHWCON = UHWCON & 0b10101111;               //              



USBCON = USBCON | 0b00010000; 
USBCON = USBCON | 0b10100000;           //Enable OTG, Enable USB and Disable Clock...
                
                
                
               
unfreeze_clk();                        //  USB

            //FULL SPEED mode


///UDADDR = 0;                                       //Reset address
UDIEN = 0;
UEINTX = 0;
}




void recieve_reset(void)
{
   
if (UDINT & 0b00001000) {   
 
 
 UEIENX = 0b11011111;
 UERST = 0b00000111;
 UERST = 0b00000000;
 UDIEN = UDIEN | 0b00000100;

 UDINT = UDINT & 0b11110111;
 UDINT =0;
 UENUM=0;
                        };

}



void recieve_setup(void)
{
   
if (UEINTX & 0b00101000) {   
 UEINTX = UEINTX & 0b11110111;
 PORTF.4=1;
 UsbControlPacketProcessed();
 
                        };

}

void recieve_sof(void)
{
   
if (UDINT & 0b00000100) {   
 UDINT = UDINT & 0b11111011;
 
 
 
                        };

}


